\section{Use Cases}
\label{sec:use_cases}




\subsection{Bank generation}
\label{sec:bank_generation}

A common task will be the creation of new banks. The described workflow here assumes that a background PSD exists and template banks have been generated.\footnote{will describe in full detail at a later time} \\


For example, the {\it submit\_30.sh} script (see section \ref{sec:submit_30}) is in the same submit directory as the {\it banks.sh} script (see section \ref{sec:banks}) that takes in system variables from within the {\it submit\_30.sh} job submission script. The {\it \_30} simply denotes the {\it latency} of the templates created: 30 seconds. \\

\subsubsection{submit\_30.sh}
\label{sec:submit_30}
\lstinputlisting[language=bash,style=mystyle]{example_code_use/submit_30.sh}


\noindent Once these jobs are finished, ie. the banks have been generated, we need to accomplish several tasks: \\


\begin{enumerate}
	 \item \indent Identify how many banks have survived the latency cut-offs, ie. how many templates are in each latency profile.
	 \item \indent Identify and reprocess select templates which have not met quality control criteria
	 \item \indent TODO: Integrate the reprocessed templates into the final banks.
\end{enumerate}


\subsubsection{bank\_postprocessing example}

The above section has created several latency profiles in the following directory: \\

run\_directory = '/fred/oz016/PSD-1263344418-21600' \\




The code snippet simply uses {\it \bf  bank\_utils.create.err\_file\_information\_report.py} (see  \ref{sec:bank_utils_create_err_status_file}) to find all {\it 'logs\_*'}  sub-string to find all directories in the {\bf run\_directory} defined above. \\


\lstinputlisting[language=bash,style=mystyle]{example_code_use/bank_postprocessing__test.py}


The reporting has now created 4 output products:
 
\begin{enumerate}
	\item verbose output to display: For an example, see section \ref{sec:verbose_output}.
	
	\item template\_bank\_report\_default.csv: a .csv file with header: \\
	
	
	NEGLAT,IFO,num\_banks \\
	
	where:
	
	\begin{enumerate}
		\item NEGLAT - negative latency value
		
		\item IFO - instrument
		
		\item num\_banks - the number of banks that survived
		
	\end{enumerate}
	
	
	\item combined\_data\_report\_for\_all\_logs.csv: a .csv file with header containing: \\
	
	\begin{enumerate}
		\item BOPTPERC
		\item SBANK
		\item NEGLAT
		\item job\_id
		\item IFO
		\item BANK
		\item template\_number
		\item m1\_mass
		\item m2\_mass
		\item epsilon\_final
		\item final\_filters
		\item match\_final
		\item epsilon\_original
		\item original\_filters
		\item match\_original
	\end{enumerate}

	
	\item templates\_to\_be\_rerun.csv: a .csv file with same header structure as combined\_data\_report\_for\_all\_logs.csv. THIS IS THE INPUT FILE FOR THE RE-CREATION OF THESE TEMPLATES USING the {\bf bank\_utils.create.select\_templates\_from\_full\_banks} method whose documentation string can be see in \ref{sec:bank_utils_select_templates_from_full_banks}.
	
	

\end{enumerate}

\subsubsection{TO DO items}
\label{sec:bank_utils_todo}

\begin{enumerate}
	\item Rewrite the job submission within a single .py method
	\item Launch a new job for each low-quality template within a completed bank of templates and 'stitch' the original and rerun templates together
	\item Formalise the job creation reporting and plots
	\item Identify which banks are in common to the different latency profiles
\end{enumerate}


\subsection{Injection run follow-up}
\label{sec:injection_examples}

Following a successful injection run, you now have to investigate the zerolag files and create some statistical summaries and plots to describe the results. The difficulty is that there will be multiple trigger files to open for multiple injection profiles and latency values. \\

In this case, there are 2 early warning sub-directories in the following directory: \\


{\it /fred/oz996/Manoj/O3b\_EW/} \\

\noindent identified by the sub\_folders list variable (see line 8 in sec \ref{sec:combined_dataframe_example}). \\


\noindent In each early warning sub-directory there are a further 17 injection sub-directories identified by a numerical string such as: 001, 002, ... , 017. \\

First, we have to construct the dynamic path to point to each relevant directory, variable {\it output\_path} (see line 20 in sec \ref{sec:combined_dataframe_example}). Once we have each relevant directory, we can then use \\

{\it postprocess\_utils.create.combined\_dataframe\_from\_xml\_files()} \\

\noindent to create a single dataframe which combines all relevant information from each of the {\it postcoh} table extracted from each *zerolag*xml.gz. The extracted variables are visible in the \\

{\it postprocess\_utils\textbackslash postcoh.csv} \\

\noindent file. You can create your own combination of TABLE\&PARAMETERS to extract from any LIGO *xml.gz file. This file will have to be saved in your respective distribution ../gwdc\_utils/postprocess\_utils/ directory. \\

Now that the above dataframes have been created, we can make relevant scatter plots such as combined $\chi^2$ {\it vs.} coherent SNR and {\it $m_1$ vs. $m_2$}. This is described in sec \ref{sec:create_scatter_plot}. \\

One of the clear benefits of having the summary files is that now, with a single {\it pandas read\_csv} function call we have access to a single data structure that can be . de-referenced to access any column vectors.


\subsubsection{combined\_dataframe\_from\_xml\_files\_\_test.py}
\label{sec:combined_dataframe_example}
\lstinputlisting[language=python,style=mystyle]{example_code_use/create_combined_dataframe_from_xml_files__test.py}


\subsubsection{create\_scatter\_plot\_\_test.py}
\label{sec:create_scatter_plot}
\lstinputlisting[language=python,style=mystyle]{example_code_use/create_scatter_plot__test.py}


\subsection{Interacting with databases}
\label{sec:database_interaction}



\subsubsection{Gracedb}
\label{sec:gracedb}



\subsubsection{GwdcDb}
\label{sec:gwdcdb}

The GwdcDb SQL server is available to facilitate the logging and storing data/tables that need to be accessible to compute nodes. This sub-module has bee
n written in order to facilitate interactions with this server. The examples described below are available in: {\bf gwdc\_utils/samples/db/}. \\

\paragraph{Test Connection:}{Before you can read from or write to the GwdcDb SQL server you must ensure a proper connection. The testConnection.py method allows you interactively tests your connection by simply running: \newline \\ \textcolor{red}{import} testConnection \newline \\ in a python REPL terminal. If successful, you will get the following message: \newline \\ \textcolor{blue}{** GWDC database: can we create a connection? \newline	Successfully connected to the database! Nice job} \newline \\} \\


\lstinputlisting[language=python,style=mystyle]{../testConnection.py}


%\lstinputlisting[language=python,style=mystyle]{../samples/db/rawSql.py}

\paragraph{Working with Pandas:}{Transferring data to and from the server can be easily accomplished through existing {\it Pandas} methods. In order to run the below example simply navigate to the gwdc\_utils/samples/db/ and run:\newline \\ \textcolor{blue}{python} pandasDataframe.py \newline \\}

\lstinputlisting[language=python,style=mystyle]{../samples/db/pandasDataframe.py}
